## ros-melodic-libcreate 2.0.0

=== CMakeLists.txt ===
# After installation this project can be found by 'find_package' command:
#
#    find_package(libcreate REQUIRED)
#    include_directores(${libcreate_INCLUDE_DIRS})
#    target_link_libraries(... ${libcreate_LIBRARIES})
#

cmake_minimum_required(VERSION 2.8.12)
project(libcreate)

add_compile_options(-Wall -Wextra -Wpedantic)

set(PACKAGE_VERSION 1.6.1)

option(LIBCREATE_BUILD_TESTS "Enable the build of tests." ON)

find_package(Boost REQUIRED COMPONENTS system thread)
find_package(Threads REQUIRED)

# Default to C++11
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
endif()

#########
# Build #
#########

set(LIBRARY_NAME create)

# Specify locations of header files
include_directories(
  include
)

# Declare cpp library
add_library(${LIBRARY_NAME} SHARED
  src/create.cpp
  src/serial.cpp
  src/serial_stream.cpp
  src/serial_query.cpp
  src/data.cpp
  src/packet.cpp
  src/types.cpp
)

# Manually link to thread library for build on ARM
if(THREADS_HAVE_PTHREAD_ARG)
  set_property(TARGET ${LIBRARY_NAME} PROPERTY COMPILE_OPTIONS "-pthread")
  set_property(TARGET ${LIBRARY_NAME} PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
endif()

if(CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(${LIBRARY_NAME} "${CMAKE_THREAD_LIBS_INIT}")
endif()

# Link to Boost
target_link_libraries(${LIBRARY_NAME}
  ${Boost_LIBRARIES}
)

# Declare example executables
set(EXAMPLES
  battery_level
  bumpers
  cliffs
  drive_circle
  leds
  packets
  play_song
  wheeldrop
)

foreach(EXAMPLE ${EXAMPLES})
  add_executable(${EXAMPLE} examples/${EXAMPLE}.cpp)

  target_link_libraries(${EXAMPLE}
    ${Boost_LIBRARIES}
    ${LIBRARY_NAME}
  )
endforeach()

#################
# Configuration #
#################

# Install directories layout:
#   * <prefix>/lib/
#   * <prefix>/bin/
#   * <prefix>/include/
#   * <prefix>/lib/cmake/<PROJECT-NAME>
#   * <prefix>/share/<PROJECT_NAME>
set(LIB_INSTALL_DIR "lib")
set(BIN_INSTALL_DIR "bin")
set(INCLUDE_INSTALL_DIR "include")
set(CONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME}")
set(SHARE_INSTALL_DIR "share/${PROJECT_NAME}")

set(GENERATED_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(VERSION_CONFIG "${GENERATED_DIR}/${PROJECT_NAME}-config-version.cmake")
set(PROJECT_CONFIG "${GENERATED_DIR}/${PROJECT_NAME}-config.cmake")
set(TARGETS_EXPORT_NAME "${PROJECT_NAME}-targets")

include(CMakePackageConfigHelpers)

# Configure '<PROJECT-NAME>-config-version.cmake'
write_basic_package_version_file(
  "${VERSION_CONFIG}"
  VERSION "${PACKAGE_VERSION}"
  COMPATIBILITY SameMajorVersion
)

# Configure '<PROJECT-NAME>-config.cmake'
configure_package_config_file(
  "config.cmake.in"
  "${PROJECT_CONFIG}"
  INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
  PATH_VARS
    INCLUDE_INSTALL_DIR
    LIBRARY_NAME
)

###########
# Install #
###########

# Install targets
install(
  TARGETS ${LIBRARY_NAME}
  EXPORT "${TARGETS_EXPORT_NAME}"
  LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
  ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
  RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
  INCLUDES DESTINATION "${INCLUDE_INSTALL_DIR}"
)

# Install headers
install(
  DIRECTORY include/
  DESTINATION ${INCLUDE_INSTALL_DIR}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

# Install config
install(
  FILES "${PROJECT_CONFIG}" "${VERSION_CONFIG}"
  DESTINATION "${CONFIG_INSTALL_DIR}"
)

# Install targets
install(
  EXPORT "${TARGETS_EXPORT_NAME}"
  DESTINATION "${CONFIG_INSTALL_DIR}"
)

# Install package.xml (for catkin)
install(
  FILES package.xml
  DESTINATION ${SHARE_INSTALL_DIR}
)

###########
# Testing #
###########

if(LIBCREATE_BUILD_TESTS)
  find_package(GTest)
  include_directories(${GTEST_INCLUDE_DIRS})
endif()

if(LIBCREATE_BUILD_TESTS AND ${GTEST_FOUND})
  message("GTest installation found. Building tests.")

  enable_testing()

  # Add tests
  set(LIBCREATE_TESTS
    test_create
    test_data
    test_packet
    test_robot_model
    test_serial_stream
    test_serial_query
  )

  foreach(LIBCREATE_TEST ${LIBCREATE_TESTS})
    add_executable(${LIBCREATE_TEST} tests/${LIBCREATE_TEST}.cpp)

    target_link_libraries(${LIBCREATE_TEST}
      ${LIBRARY_NAME}
      ${GTEST_LIBRARIES}
      gtest_main
    )

    add_test(
      NAME ${LIBCREATE_TEST}
      COMMAND ${LIBCREATE_TEST}
    )
  endforeach()
else()
  message("No GTest installation found. Skipping tests.")
endif()

=== debian/changelog ===
ros-melodic-libcreate (2.0.0-1stretch) stretch; urgency=high

  * Cleanup examples
  * Use std::chrono instead of custom timestamp function
  * Remove Trusty CI job
    * Since it is EOL.
  * Default to C++11
  * Add compiler flags '-Wall -Wextra -Wpedantic'
    * Fix warnings as a result.
  * Disconnect from serial cleanly on SIGINT
    * Send the STOP opcode before exiting the program to ensure the robot is not left in a state that could potentially drain the battery.
  * Initialize variable for compiler compatibility
  * Add other serial communication options
    Otherwise, it's possible that Operation "7" (0x07) is confused for "135" (0x87)
  * Add cliff sensor example
  * Add API for getting left and right cliff detections
  * Update wheeldrop example
  * Add API for getting left and right wheeldrop
  * Use shared pointer when binding callback for serial read (#38 <https://github.com/autonomylab/libcreate/issues/38>)
    * Resolves an issue with ROS Melodic on 18.04.
  * Fix for compatibility with Boost 1.66
    * Compatibility with at least as early as Boost 1.58 still persists
  * Update wheel diameter for Create 2
    * Now matches the spec from iRobot.
  * Add Bionic CI job
  * Add static cast to fix compiler warnings
  * Use package.xml format 3
    * Make catkin dependency conditional on ROS 1.
  * Add Xenial build to CI
  * Remove std::cout statement
  * Contributors: Anton Gerasimov, Jacob Perron, Ryota Suzuki, Yutaka Kondo

 -- Jacob Perron <jacobmperron@gmail.com>  Mon, 02 Sep 2019 07:00:00 -0000

ros-melodic-libcreate (1.6.1-1stretch) stretch; urgency=high

  * Build and install gtest as part of CI
  * Update README with instructions for building and running unit tests
  * Remove external cmake project for gtest
    Now only build tests if a gtest installation already exists on the system. This should expedite time to build for users that do not care about building/running unit tests and also eliminates the need for internet access when building.
  * Add test depend to gtest in package.xml
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 21 Apr 2018 07:00:00 -0000

ros-melodic-libcreate (1.6.0-1stretch) stretch; urgency=high

  * Add unit tests (gtests)
  * Refactor Packet API
    
    Declare setData member as protected
    
    Rename 'setTempData' to 'setDataToValidate'
  * Remove redundant packets from Data constructor
  * Updated setDigits function API comments
    
    added HTML to adjust for spacing in diagram, showing the proper ordering of segments.
  * Update examples
    
    More concise and focusing on individual features:
    
    Battery level
    
    Bumpers
    
    Drive circle
    
    LEDs
    
    Serial packets
    
    Play song
    
    Wheeldrop
  * Update README
  * Refactor cmake files
  * Contributors: Jacob Perron, K.Moriarty

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 07 Apr 2018 07:00:00 -0000

ros-melodic-libcreate (1.5.0-1stretch) stretch; urgency=high

  * Add APIs for getting the measured velocities of the wheels
  * Add ability to drive the wheels with direct pwm duty
  * Update documentation
  * Add mainpage.dox
  * Use package.xml format 2
  * Add doxygen as doc dependency
  * Contributors: Erik Schembor, Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sun, 17 Dec 2017 08:00:00 -0000

ros-melodic-libcreate (1.4.0-1stretch) stretch; urgency=high

  * Switch to trusty for CI
  * Set mimumum cmake version to 2.8.12
  * Update CMakeLists.txt configuration and install rules
  * Add package.xml
  * Add config.cmake.in
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sun, 16 Oct 2016 07:00:00 -0000

ros-melodic-libcreate (1.3.0-1stretch) stretch; urgency=high

  * Add support for early model Roomba 400s and other robots using the original SCI protocol.
  * Expose individual wheel distances and requested velocities. Fix wheel distance calculation for the Create 1.
  * Manually link to thread library. This allows libcreate to build on ARM.
  * Fix odometry inversion for Create 1.
  * Contributors: Ben Wolsieffer, Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Tue, 23 Aug 2016 07:00:00 -0000

ros-melodic-libcreate (1.2.1-1stretch) stretch; urgency=high

  * Make velocity relative to base frame, not odometry frame
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 30 Apr 2016 07:00:00 -0000

ros-melodic-libcreate (1.2.0-1stretch) stretch; urgency=high

  * Add covariance info to Pose and Vel
  * Fix getMode bug
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Fri, 15 Apr 2016 07:00:00 -0000

ros-melodic-libcreate (1.1.1-1stretch) stretch; urgency=high

  * Fix odometry sign error
  * Add warning in code regarding Create 1 odometry issue
  * Add odom_example.cpp
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Thu, 07 Apr 2016 07:00:00 -0000

ros-melodic-libcreate (1.1.0-1stretch) stretch; urgency=high

  * Add API to get light sensor signals
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 02 Apr 2016 07:00:00 -0000

ros-melodic-libcreate (1.0.0-1stretch) stretch; urgency=high

  * Fix odometry for Create 1
  * Fix odom angle sign error
  * Convert units to base units
  * Implement 'getMode'
  * Rename 'isIRDetect*' functions to 'isLightBumper*'
  * Documentation / code cleanup
  * Add function 'driveRadius'
  * Add function 'isVirtualWall'
  * Fix sign error on returned 'current' and 'temperature'
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Fri, 01 Apr 2016 07:00:00 -0000

ros-melodic-libcreate (0.1.1-1stretch) stretch; urgency=high

  * Fix odometry bug
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Fri, 25 Mar 2016 07:00:00 -0000

ros-melodic-libcreate (0.1.0-1stretch) stretch; urgency=high

  * Add enum of special IR characters
  * Fix bug: convert distance measurement to meters


=== debian/control ===
Source: ros-melodic-libcreate
Section: misc
Priority: extra
Maintainer: Jacob Perron <jacobmperron@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libgtest-dev
Homepage: http://wiki.ros.org/libcreate
Standards-Version: 3.9.2

Package: ros-melodic-libcreate
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-melodic-catkin
Description: C++ library for interfacing with iRobot's Create 1 and Create 2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-libcreate//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
